package com.hai.dao;

import com.hai.entity.HighReserveMsg;
import com.hai.entity.HighReserveMsgExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface HighReserveMsgMapper extends HighReserveMsgMapperExt {
    @SelectProvider(type=HighReserveMsgSqlProvider.class, method="countByExample")
    long countByExample(HighReserveMsgExample example);

    @DeleteProvider(type=HighReserveMsgSqlProvider.class, method="deleteByExample")
    int deleteByExample(HighReserveMsgExample example);

    @Delete({
        "delete from high_reserve_msg",
        "where id = #{id,jdbcType=INTEGER}"
    })
    int deleteByPrimaryKey(Integer id);

    @Insert({
        "insert into high_reserve_msg (goods_name, order_id, ",
        "pay_price, reserve_remark, ",
        "reserve_time, user_name, ",
        "user_phone, created_user_id, ",
        "created_time, updated_user_id, ",
        "updated_time, `status`, ",
        "ext_1, ext_2, ext_3)",
        "values (#{goodsName,jdbcType=VARCHAR}, #{orderId,jdbcType=VARCHAR}, ",
        "#{payPrice,jdbcType=DECIMAL}, #{reserveRemark,jdbcType=VARCHAR}, ",
        "#{reserveTime,jdbcType=TIMESTAMP}, #{userName,jdbcType=VARCHAR}, ",
        "#{userPhone,jdbcType=VARCHAR}, #{createdUserId,jdbcType=VARCHAR}, ",
        "#{createdTime,jdbcType=TIMESTAMP}, #{updatedUserId,jdbcType=VARCHAR}, ",
        "#{updatedTime,jdbcType=TIMESTAMP}, #{status,jdbcType=INTEGER}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(HighReserveMsg record);

    @InsertProvider(type=HighReserveMsgSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(HighReserveMsg record);

    @SelectProvider(type=HighReserveMsgSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.INTEGER, id=true),
        @Result(column="goods_name", property="goodsName", jdbcType=JdbcType.VARCHAR),
        @Result(column="order_id", property="orderId", jdbcType=JdbcType.VARCHAR),
        @Result(column="pay_price", property="payPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="reserve_remark", property="reserveRemark", jdbcType=JdbcType.VARCHAR),
        @Result(column="reserve_time", property="reserveTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="user_name", property="userName", jdbcType=JdbcType.VARCHAR),
        @Result(column="user_phone", property="userPhone", jdbcType=JdbcType.VARCHAR),
        @Result(column="created_user_id", property="createdUserId", jdbcType=JdbcType.VARCHAR),
        @Result(column="created_time", property="createdTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="updated_user_id", property="updatedUserId", jdbcType=JdbcType.VARCHAR),
        @Result(column="updated_time", property="updatedTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<HighReserveMsg> selectByExample(HighReserveMsgExample example);

    @Select({
        "select",
        "id, goods_name, order_id, pay_price, reserve_remark, reserve_time, user_name, ",
        "user_phone, created_user_id, created_time, updated_user_id, updated_time, `status`, ",
        "ext_1, ext_2, ext_3",
        "from high_reserve_msg",
        "where id = #{id,jdbcType=INTEGER}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.INTEGER, id=true),
        @Result(column="goods_name", property="goodsName", jdbcType=JdbcType.VARCHAR),
        @Result(column="order_id", property="orderId", jdbcType=JdbcType.VARCHAR),
        @Result(column="pay_price", property="payPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="reserve_remark", property="reserveRemark", jdbcType=JdbcType.VARCHAR),
        @Result(column="reserve_time", property="reserveTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="user_name", property="userName", jdbcType=JdbcType.VARCHAR),
        @Result(column="user_phone", property="userPhone", jdbcType=JdbcType.VARCHAR),
        @Result(column="created_user_id", property="createdUserId", jdbcType=JdbcType.VARCHAR),
        @Result(column="created_time", property="createdTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="updated_user_id", property="updatedUserId", jdbcType=JdbcType.VARCHAR),
        @Result(column="updated_time", property="updatedTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    HighReserveMsg selectByPrimaryKey(Integer id);

    @UpdateProvider(type=HighReserveMsgSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") HighReserveMsg record, @Param("example") HighReserveMsgExample example);

    @UpdateProvider(type=HighReserveMsgSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") HighReserveMsg record, @Param("example") HighReserveMsgExample example);

    @UpdateProvider(type=HighReserveMsgSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(HighReserveMsg record);

    @Update({
        "update high_reserve_msg",
        "set goods_name = #{goodsName,jdbcType=VARCHAR},",
          "order_id = #{orderId,jdbcType=VARCHAR},",
          "pay_price = #{payPrice,jdbcType=DECIMAL},",
          "reserve_remark = #{reserveRemark,jdbcType=VARCHAR},",
          "reserve_time = #{reserveTime,jdbcType=TIMESTAMP},",
          "user_name = #{userName,jdbcType=VARCHAR},",
          "user_phone = #{userPhone,jdbcType=VARCHAR},",
          "created_user_id = #{createdUserId,jdbcType=VARCHAR},",
          "created_time = #{createdTime,jdbcType=TIMESTAMP},",
          "updated_user_id = #{updatedUserId,jdbcType=VARCHAR},",
          "updated_time = #{updatedTime,jdbcType=TIMESTAMP},",
          "`status` = #{status,jdbcType=INTEGER},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=INTEGER}"
    })
    int updateByPrimaryKey(HighReserveMsg record);
}